-- file test_gates.vhdl
-- created ven. août  9 03:14:28 CEST 2019
-- version sam. août 10 16:08:18 CEST 2019


Library ieee;
    use ieee.std_logic_1164.all;
Library proasic3;
    use proasic3.all;

entity test_gates is
  generic (
    gate_select_number: integer := 0;
    bit_select_number: integer := -1
  );
end test_gates;

architecture rtl of test_gates is
  signal A, B, C, D, E, F, Y : std_logic;
  signal clock : std_logic := '0';
begin
  -- this entity MUST be written first,
  -- at the very beginning of the toplevel file:
  rg: entity register_generics port map(
       gate_select_number => gate_select_number,
       bit_select_number => bit_select_number,
       clock => clock);

  x1: entity xor2  port map(A => A, B=>B,  Y=>E );
  x2: entity xor2  port map(A => C, B=>E,  Y=>F );
  x3: entity xor2  port map(A => D, B=>F,  Y=>Y );

  test: process
  begin
    if gate_select_number=-1 then
      wait;
    end if;

    wait for 100 ns;

    A <= '0';
    loop

      B <= '0';
      loop

	C <= '0';
        loop

          D <= '0';
          loop

            clock <= '0';
            wait for 10 ns;
            clock <= '1';
            wait for 10 ns;
            report  " A=" & std_logic'image(A) &
                    " B=" & std_logic'image(B) &
                    " C=" & std_logic'image(C) &
                    " D=" & std_logic'image(D) &
                    " E=" & std_logic'image(E) &
                    " F=" & std_logic'image(E) &
                    " Y=" & std_logic'image(Y);

            exit when D = '1';
            D <= '1';
          end loop;

          exit when C = '1';
          C <= '1';
        end loop;

        exit when B = '1';
        B <= '1';
      end loop;

      exit when A = '1';
      A <= '1';
    end loop;

    clock<='X'; -- display the histogram
    wait;
  end process;

end rtl;
